package org.zeroturnaround.javarebel.integration.spring;

import org.springframework.aop.framework.Advised;
import org.zeroturnaround.javarebel.LoggerFactory;

/**
 * @author Rein Raudjärv
 */
public class SpringAopUtil {
  
  private static final boolean ENABLED = isEnabled();

  public static Object unwrapAdvisedBean(Object bean) {
    if (ENABLED) {
      // Unwrapping Advised beans
      try {
        while (bean instanceof Advised) {
          bean = ((Advised) bean).getTargetSource().getTarget();
        }
      } catch (Exception e) {
        LoggerFactory.getInstance().error(e);
      }
    }
    return bean;
  }

  private static boolean isEnabled() {
    try {
      Advised.class.getName();
      return true;
    } catch (NoClassDefFoundError e) {
      return false;
    }
  }
  
}
