package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>org.springframework.beans.factory.config.PropertyResourceConfigurer</code>.
 * 
 * @author Rein Raudjärv
 */
public class PropertyResourceConfigurerCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    
    cp.importPackage("org.zeroturnaround.javarebel.integration.spring.prop");
    
    ctClass.getDeclaredMethod("postProcessBeanFactory").insertAfter(
        "{" +
        "  PropertyResourceConfigurerHelper.get($1).register($0);" +
        "}");
  }
}
